
#define F_CPU 16000000

#include <stdint.h> 
#include "dm_lcd.h"

void RESET(void);	
void init_ports(void);  		// ports perso 	DDRx 0=entree, 1=sortie
void InitINTs(void);  
void initADC(void);
void GetADC(void);
int RecvRC5 (void);
int32_t abs_int32(int32_t x);
void strcpy_a_n(char *CH1, char *CH2, uint8_t a, uint8_t n);
uint8_t isNumeric(char *CH1);
void _delay_s(int8_t nb_s);
void RAZ_tempos(void);
void Timer1_setTime(int t);  // en microsecondes
void vitesse_mini(uint8_t ocr2_i);
void relais1_on(void);
void relais1_off(void);
void relais2_on(void);
void relais2_off(void);
void EV2_on(void); // commande électrovanne2. //(on peut en rajouter... pour le prelavage par exemple...)
void EV2_off(void);
void CHAUFFAGE_off(void);
void CHAUFFAGE_on(void);
void POMPE_on(void);
void POMPE_off(void);
void interroge_IR(void);
void PAUSER(char str1[20+1]);
void detection_bouton_ROUGE(void);
void lcd_aff_nb (int32_t valeur1, uint8_t nb_chiffres, uint8_t position_pt_decimal, char affi_zero );
void lcd_aff_bin (unsigned long int valeur, int nb_digits);
void test_IR(void);
void lcd_gotoxy_clrEOL (int x, int y);
uint32_t StrTo_uint32 (char *string1);
void Event_1s(void);
// uint16_t saisie_nombre (uint8_t nb_chiffres, uint16_t valeur_max);
void detection_niveau_eau(void);  // j'ai supprimé la detection du niveau2 (3/4 de cuve, c'est trop)
void init_variables(void);
void eteint_toutes_LED(void);
void  allume_LED(uint8_t num); //  num in [0..17]
void detection_bouton_VERT(void); // ABREGE le lavage ou le rincage en cours (passe au numero suivant=vidange)
void asservissement_vitesse(uint16_t P_cons_i);
uint8_t regulation_TEMPERATURE(void);
void change_SENS(uint8_t ocr2_i);
void Affiche_temps(uint16_t nb_secondes);
void AFFICHAGES(void); // permsise toutes les secondes par le flag affi_requis.
void demarrage(uint8_t sens, uint8_t ocr2_i);
void DEFOULER(void);
void ESSORER(void);
void VIDANGER(void);
void remplissage_NIV1(uint16_t tps_plus); // par EV2
void RINCER(uint8_t num_rincage);
void PURGER(void);  // mini essorage à la fin de la vidange afin de purger l'eau du linge
void LAVER(uint16_t tps);
void choix_programme(void);
void numero_15(void);                    // ESSORAGE
void numero_14(void);                     // RINCAGE 4   facultatif
void numero_13(void);
void numero_12(void);
void numero_11(void);                     // RINCAGE 3  facultatif
void numero_10(void);
void numero_9(void);  // vidange
void numero_8(void);   // RINCAGE 2
void numero_7(void);  // remplissage
void numero_6(void);  // VIDANGE
void numero_5(void);   // RINCAGE 1
void numero_4(void);  // remplissage
void numero_3(void);  // PURGE
void numero_2(void);  // LAVAGE
void numero_1(void);  // remplissage
void numero_0(void);
void prelaver(void);
void choix_numero(void);
void TEST(void);
